## coccinelle 1.0.8.deb

=== Makefile ===
--- 
+++ 
@@ -98,12 +98,10 @@
 
 PREFIX_spgen := tools/spgen/source/
 
-STDCOMPATDIR := bundles/stdcompat
-
 CORE_LIBS := unix bigarray str \
+	$(STDCOMPATDIR)/stdcompat \
 	$(patsubst %,bytes,$(BYTESDIR)) \
-	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS))) \
-	$(STDCOMPATDIR)/stdcompat
+	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS)))
 
 ifeq ($(FEATURE_OCAML),1)
 CORE_LIBS += dynlink
@@ -119,7 +117,7 @@
 
 LIBRARIES_spgen := $(CORE_LIBRARIES)
 
-CORE_BUNDLES=menhirLib pcre stdcompat
+CORE_BUNDLES=stdcompat menhirLib pcre
 
 ALL_BUNDLES=$(CORE_BUNDLES) parmap pyml
 
@@ -381,7 +379,7 @@
 %.ml : %.mll
 	$(RUN_OCAMLLEX) $<
 
-ml_files := $(ml_files_but_parsers) parsing_c/parser_c.ml
+ml_files := $(ml_files_but_parsers) parsing_c/parser_c.ml parsing_cocci/parser_cocci_menhir.ml
 ml_and_mli_files := $(ml_files) $(ml_files:.ml=.mli)
 
 ifneq ($(MAKECMDGOALS),clean)
