=== debian/changelog ===
coccinelle (1.0.8.deb-2) unstable; urgency=medium

  * Team upload.
  * Patch installation-bytecode-only: fix installation on bytecode-only
    architectures.

 -- Ralf Treinen <treinen@debian.org>  Sat, 04 Apr 2020 16:24:07 +0200

coccinelle (1.0.8.deb-1) unstable; urgency=medium

  * Team upload

  [ Emmanuel Arias ]
  * New upstream version 1.0.8.deb
  * New Maintainer (Closes: #886679)
    - Add myself to Uploaders field on d/control
  * Update d/control file
    - Bump debhelper to debhelper-compat (=12)
  * Remove d/compat
  * Run wrap-and-sort
  * Bump Standards-Versions to 4.4.1
  * Update no-bundles.patch
  * Remove unnecessary line on d/gbp.conf
  * Apply patch to remove pygtk dependencies (Closes: #885267).
  * d/patches: Fix no-bundles.diff patch.
  * d/salsa-ci.yml: enable salsa-ci

  [ Ralf Treinen ]
  * Drop patch no-stdcompat.diff, build-depend on libstdcompat-ocaml-dev
  * Create directory usr/lib/coccinelle/python/coccilib
  * debian/rules: drop --parallel argument to dh which is now the default
  * Drop override of dh_dwz which is no longer needed
  * Drop override of dh_clean, put extra files to remove into debian/clean
  * Dropped some build-dependencies:
    - dh-autoreconf (not needed with debhelper compat level 12)
    - libpycaml-ocaml-dev (as indicated by upstream's install.txt)
    - camlp4 (no longer needed, according to the upstream team)
    - hevea (we are not building documentation in html format)
    - latexmk (not needed to build the documentation)
    - ocaml-best-compilers (which is now purely virtual)
  * Move texlive-* build-dependencies to Build-Depends-Indep
  * Dropped some dependencies of the coccinelle binary package as they
    are no run-time dependencies according to upstream:
    - libpycaml-ocaml (python2 removal)
    - python-glade2 (python2 removal)
    - python-gobject-2 (deprecated)
  * Bump build-dependency on python to python3, switch dh plugin from
    python2 to python3 (closes: #936314, #952461)
  * Simplify build:
    - in the build-indep override, just invoke "$(MAKE) docs/manual pdf"
    - drop the build-arch override
    - consequently, drop the patch pdf-docs-build which is no longer useful
  * Add as-installed test
  * Adjust doc-base files as documentation is now installed into
    /usr/share/doc/coccinelle
  * Standards-Version 4.5.0 (no change)
  * Set "Multi-Arch: foreign" for coccinelle-doc 

 -- Ralf Treinen <treinen@debian.org>  Sat, 04 Apr 2020 10:37:51 +0200

coccinelle (1.0.7.deb-1) experimental; urgency=medium

  * New upstream release 
  * Update debian/watch to download releases from Github
  * Point Vcs fields to salsa.debian.org
  * Update debian/repack.sh 
  * Removed patches:
    - notparallel-main-makefile.diff
    - bash-completion-dir.diff
    - fix-noopt-FTBFS.diff 
  * New patches:
    - no-bundles.diff - don't attempt to clean bundles, they were removed by
      debian/repack.sh
    - manual-build-fix.diff - fix building of the manual (closes: #917490)
    - no-stdcompat.diff - don't use stdcompat library, it is not present in
      Debian
    - add-no_pycocci.mli.diff - add no_pycocci.mli so coccinelle can be built
      without Python support 
    - dont-update-test-score.diff - don't update test score so spatch doesn't
      ask questions during build
    - dont-expose-parmap.diff - don't include parmap inside the package
  * Don't install spatch wrapper script, it is not used anymore
  * Don't call "make depend" in debian/rules - the target does not exist
    anymore
  * Don't call "make all" in ocaml subdirectory, this is not needed anymore 
  * Ignore failed tests for now

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 06 Jan 2019 20:36:50 +0100

coccinelle (1.0.6.deb-3) experimental; urgency=medium

  * Pass --disable-opt to configure instead of just not passing --enable-opt
    on architectures without native compilers (again, closes: #886714)
  * New patch:
    - fix-noopt-FTBFS.diff - do not force using optimized compiler so
      --disable-opt actually works
  * Use dh-autoreconf during build

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 10 Jan 2018 00:51:13 +0100

coccinelle (1.0.6.deb-2) experimental; urgency=medium

  * Use --enable-opt configure option instead of --enable-release, this should
    fix FTBFS on some architectures (closes: #886714)

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 09 Jan 2018 22:03:55 +0100

coccinelle (1.0.6.deb-1) experimental; urgency=medium

  * New upstream release (closes: #852412)
  * Upload to experimental: no Python support
  * Refresh bash-completion-dir.diff
  * Debhelper compatibility level 9
  * Use secure VCS URLs in debian/copyright
  * Standards-Version 4.1.1 - no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 30 Oct 2017 21:06:45 +0100

coccinelle (1.0.4.deb-3) unstable; urgency=medium

  * Fix package name spelling in the package description, thanks to Thomas
    Vincent for reporting (closes: #824224)

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 16 May 2016 22:37:11 +0200
