=== debian/tests/control ===
Tests: cocci-demo
Depends: coccinelle, patch
